All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
XMPP::Roster Class Reference

`#include <xmpp_roster.h>`

Inheritance diagram for XMPP::Roster:

## Classes

class | Item

## Public Types

enum | ItemType { None, To, From, Both, Unknown = 999 }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PLIST (ItemList, Item)
| Roster (XMPP::C2S::StreamHandler *handler=0)
| ~Roster ()
const ItemList & | GetItems () const
virtual Item * | FindItem (const PString &jid)
virtual PBoolean | SetItem (Item *item, PBoolean localOnly=false)
virtual PBoolean | RemoveItem (const PString &jid, PBoolean localOnly=false)
virtual PBoolean | RemoveItem (Item *item, PBoolean localOnly=false)
virtual void | Attach (XMPP::C2S::StreamHandler *handler)
virtual void | Detach ()
virtual void | Refresh (PBoolean sendPresence=true)
virtual PNotifierList & | ItemChangedHandlers ()
virtual PNotifierList & | RosterChangedHandlers ()
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

| PDECLARE_NOTIFIER (XMPP::C2S::StreamHandler, Roster, OnSessionEstablished)
| PDECLARE_NOTIFIER (XMPP::C2S::StreamHandler, Roster, OnSessionReleased)
| PDECLARE_NOTIFIER (XMPP::Presence, Roster, OnPresence)
| PDECLARE_NOTIFIER (XMPP::IQ, Roster, OnIQ)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

ItemList | m_Items
XMPP::C2S::StreamHandler * | m_Handler
PNotifierList | m_ItemChangedHandlers
PNotifierList | m_RosterChangedHandlers

## Member Enumeration Documentation

enum XMPP::Roster::ItemType

Enumerator
None |
To |
From |
Both |
Unknown |

## Constructor & Destructor Documentation

XMPP::Roster::Roster | ( | XMPP::C2S::StreamHandler * | handler = `0` | ) |

XMPP::Roster::~Roster | ( |  | ) |

## Member Function Documentation

virtual void XMPP::Roster::Attach | ( | XMPP::C2S::StreamHandler * | handler | ) |

virtual

virtual void XMPP::Roster::Detach | ( |  | ) |

virtual

virtual Item* XMPP::Roster::FindItem | ( | const PString & | jid | ) |

virtual

const ItemList& XMPP::Roster::GetItems | ( |  | ) | const

inline

References m_Items.

virtual PNotifierList& XMPP::Roster::ItemChangedHandlers | ( |  | ) |

inline virtual

References m_ItemChangedHandlers.

XMPP::Roster::PDECLARE_NOTIFIER | ( | XMPP::C2S::StreamHandler | ,
|  | Roster | ,
|  | OnSessionEstablished |
| ) |  |

protected

XMPP::Roster::PDECLARE_NOTIFIER | ( | XMPP::C2S::StreamHandler | ,
|  | Roster | ,
|  | OnSessionReleased |
| ) |  |

protected

XMPP::Roster::PDECLARE_NOTIFIER | ( | XMPP::Presence | ,
|  | Roster | ,
|  | OnPresence |
| ) |  |

protected

XMPP::Roster::PDECLARE_NOTIFIER | ( | XMPP::IQ | ,
|  | Roster | ,
|  | OnIQ |
| ) |  |

protected

XMPP::Roster::PLIST | ( | ItemList | ,
|  | Item |
| ) |  |

virtual void XMPP::Roster::Refresh | ( | PBoolean | sendPresence = `true` | ) |

virtual

virtual PBoolean XMPP::Roster::RemoveItem | ( | const PString & | jid,
|  | PBoolean | localOnly = `false`
| ) |  |

virtual

virtual PBoolean XMPP::Roster::RemoveItem | ( | Item * | item,
|  | PBoolean | localOnly = `false`
| ) |  |

virtual

virtual PNotifierList& XMPP::Roster::RosterChangedHandlers | ( |  | ) |

inline virtual

References m_RosterChangedHandlers.

virtual PBoolean XMPP::Roster::SetItem | ( | Item * | item,
|  | PBoolean | localOnly = `false`
| ) |  |

virtual

## Member Data Documentation

XMPP::C2S::StreamHandler* XMPP::Roster::m_Handler

protected

PNotifierList XMPP::Roster::m_ItemChangedHandlers

protected

Referenced by ItemChangedHandlers().

ItemList XMPP::Roster::m_Items

protected

Referenced by GetItems().

PNotifierList XMPP::Roster::m_RosterChangedHandlers

protected

Referenced by RosterChangedHandlers().

The documentation for this class was generated from the following file:

- xmpp_roster.h